/*
  File autogenerated by gengetopt version 2.22.6
  generated with the following command:
  gengetopt --no-help -l -F hdf5-clo --unamed-opts --no-help --long-help -a hdf5_args_info -f hdf5_parser

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FIX_UNUSED
#define FIX_UNUSED(X) (void) (X) /* avoid warnings for unused params */
#endif

#include <getopt.h>

#include "hdf5-clo.h"

const char *hdf5_args_info_purpose = "";

const char *hdf5_args_info_usage = "Usage: ute print -f hdf5 [OPTIONS...] FILEs...";

const char *hdf5_args_info_versiontext = "";

const char *hdf5_args_info_description = "Dump ute files in HDF5 format.";

const char *hdf5_args_info_help[] = {
  "  -V, --version        Print version and exit",
  "  -h, --help           Show this help message.",
  "\nInput options:",
  "  -f, --format=FORMAT  Use the specified parser, see below for a list.",
  "\nOutput options:",
  "  -o, --output=FILE    Write result to specified output file, or stdout if\n                         omitted.",
  "      --compound       Use the compound data type to tightly couple timestamps\n                         and values.",
  "      --matlab         Make the generated file easy to read with matlab.",
    0
};

typedef enum {ARG_NO
  , ARG_STRING
} hdf5_parser_arg_type;

static
void clear_given (struct hdf5_args_info *args_info);
static
void clear_args (struct hdf5_args_info *args_info);

static int
hdf5_parser_internal (int argc, char **argv, struct hdf5_args_info *args_info,
                        struct hdf5_parser_params *params, const char *additional_error);


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct hdf5_args_info *args_info)
{
  args_info->version_given = 0 ;
  args_info->help_given = 0 ;
  args_info->format_given = 0 ;
  args_info->output_given = 0 ;
  args_info->compound_given = 0 ;
  args_info->matlab_given = 0 ;
}

static
void clear_args (struct hdf5_args_info *args_info)
{
  FIX_UNUSED (args_info);
  args_info->format_arg = NULL;
  args_info->format_orig = NULL;
  args_info->output_arg = NULL;
  args_info->output_orig = NULL;
  
}

static
void init_args_info(struct hdf5_args_info *args_info)
{


  args_info->version_help = hdf5_args_info_help[0] ;
  args_info->help_help = hdf5_args_info_help[1] ;
  args_info->format_help = hdf5_args_info_help[3] ;
  args_info->output_help = hdf5_args_info_help[5] ;
  args_info->compound_help = hdf5_args_info_help[6] ;
  args_info->matlab_help = hdf5_args_info_help[7] ;
  
}

void
hdf5_parser_print_version (void)
{
  printf ("%s %s\n",
     (strlen(HDF5_PARSER_PACKAGE_NAME) ? HDF5_PARSER_PACKAGE_NAME : HDF5_PARSER_PACKAGE),
     HDF5_PARSER_VERSION);

  if (strlen(hdf5_args_info_versiontext) > 0)
    printf("\n%s\n", hdf5_args_info_versiontext);
}

static void print_help_common(void) {
  hdf5_parser_print_version ();

  if (strlen(hdf5_args_info_purpose) > 0)
    printf("\n%s\n", hdf5_args_info_purpose);

  if (strlen(hdf5_args_info_usage) > 0)
    printf("\n%s\n", hdf5_args_info_usage);

  printf("\n");

  if (strlen(hdf5_args_info_description) > 0)
    printf("%s\n\n", hdf5_args_info_description);
}

void
hdf5_parser_print_help (void)
{
  int i = 0;
  print_help_common();
  while (hdf5_args_info_help[i])
    printf("%s\n", hdf5_args_info_help[i++]);
}

void
hdf5_parser_init (struct hdf5_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);

  args_info->inputs = 0;
  args_info->inputs_num = 0;
}

void
hdf5_parser_params_init(struct hdf5_parser_params *params)
{
  if (params)
    { 
      params->override = 0;
      params->initialize = 1;
      params->check_required = 1;
      params->check_ambiguity = 0;
      params->print_errors = 1;
    }
}

struct hdf5_parser_params *
hdf5_parser_params_create(void)
{
  struct hdf5_parser_params *params = 
    (struct hdf5_parser_params *)malloc(sizeof(struct hdf5_parser_params));
  hdf5_parser_params_init(params);  
  return params;
}

static void
free_string_field (char **s)
{
  if (*s)
    {
      free (*s);
      *s = 0;
    }
}


static void
hdf5_parser_release (struct hdf5_args_info *args_info)
{
  unsigned int i;
  free_string_field (&(args_info->format_arg));
  free_string_field (&(args_info->format_orig));
  free_string_field (&(args_info->output_arg));
  free_string_field (&(args_info->output_orig));
  
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);

  if (args_info->inputs_num)
    free (args_info->inputs);

  clear_given (args_info);
}


static void
write_into_file(FILE *outfile, const char *opt, const char *arg, const char *values[])
{
  FIX_UNUSED (values);
  if (arg) {
    fprintf(outfile, "%s=\"%s\"\n", opt, arg);
  } else {
    fprintf(outfile, "%s\n", opt);
  }
}


int
hdf5_parser_dump(FILE *outfile, struct hdf5_args_info *args_info)
{
  int i = 0;

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot dump options to stream\n", HDF5_PARSER_PACKAGE);
      return EXIT_FAILURE;
    }

  if (args_info->version_given)
    write_into_file(outfile, "version", 0, 0 );
  if (args_info->help_given)
    write_into_file(outfile, "help", 0, 0 );
  if (args_info->format_given)
    write_into_file(outfile, "format", args_info->format_orig, 0);
  if (args_info->output_given)
    write_into_file(outfile, "output", args_info->output_orig, 0);
  if (args_info->compound_given)
    write_into_file(outfile, "compound", 0, 0 );
  if (args_info->matlab_given)
    write_into_file(outfile, "matlab", 0, 0 );
  

  i = EXIT_SUCCESS;
  return i;
}

int
hdf5_parser_file_save(const char *filename, struct hdf5_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", HDF5_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  i = hdf5_parser_dump(outfile, args_info);
  fclose (outfile);

  return i;
}

void
hdf5_parser_free (struct hdf5_args_info *args_info)
{
  hdf5_parser_release (args_info);
}

/** @brief replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = 0;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
hdf5_parser (int argc, char **argv, struct hdf5_args_info *args_info)
{
  return hdf5_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
hdf5_parser_ext (int argc, char **argv, struct hdf5_args_info *args_info,
                   struct hdf5_parser_params *params)
{
  int result;
  result = hdf5_parser_internal (argc, argv, args_info, params, 0);

  if (result == EXIT_FAILURE)
    {
      hdf5_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
hdf5_parser2 (int argc, char **argv, struct hdf5_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  struct hdf5_parser_params params;
  
  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;
  params.print_errors = 1;

  result = hdf5_parser_internal (argc, argv, args_info, &params, 0);

  if (result == EXIT_FAILURE)
    {
      hdf5_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
hdf5_parser_required (struct hdf5_args_info *args_info, const char *prog_name)
{
  FIX_UNUSED (args_info);
  FIX_UNUSED (prog_name);
  return EXIT_SUCCESS;
}


static char *package_name = 0;

/**
 * @brief updates an option
 * @param field the generic pointer to the field to update
 * @param orig_field the pointer to the orig field
 * @param field_given the pointer to the number of occurrence of this option
 * @param prev_given the pointer to the number of occurrence already seen
 * @param value the argument for this option (if null no arg was specified)
 * @param possible_values the possible values for this option (if specified)
 * @param default_value the default value (in case the option only accepts fixed values)
 * @param arg_type the type of this option
 * @param check_ambiguity @see hdf5_parser_params.check_ambiguity
 * @param override @see hdf5_parser_params.override
 * @param no_free whether to free a possible previous value
 * @param multiple_option whether this is a multiple option
 * @param long_opt the corresponding long option
 * @param short_opt the corresponding short option (or '-' if none)
 * @param additional_error possible further error specification
 */
static
int update_arg(void *field, char **orig_field,
               unsigned int *field_given, unsigned int *prev_given, 
               char *value, const char *possible_values[],
               const char *default_value,
               hdf5_parser_arg_type arg_type,
               int check_ambiguity, int override,
               int no_free, int multiple_option,
               const char *long_opt, char short_opt,
               const char *additional_error)
{
  char *stop_char = 0;
  const char *val = value;
  int found;
  char **string_field;
  FIX_UNUSED (field);

  stop_char = 0;
  found = 0;

  if (!multiple_option && prev_given && (*prev_given || (check_ambiguity && *field_given)))
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: `--%s' (`-%c') option given more than once%s\n", 
               package_name, long_opt, short_opt,
               (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: `--%s' option given more than once%s\n", 
               package_name, long_opt,
               (additional_error ? additional_error : ""));
      return 1; /* failure */
    }

  FIX_UNUSED (default_value);
    
  if (field_given && *field_given && ! override)
    return 0;
  if (prev_given)
    (*prev_given)++;
  if (field_given)
    (*field_given)++;
  if (possible_values)
    val = possible_values[found];

  switch(arg_type) {
  case ARG_STRING:
    if (val) {
      string_field = (char **)field;
      if (!no_free && *string_field)
        free (*string_field); /* free previous string */
      *string_field = gengetopt_strdup (val);
    }
    break;
  default:
    break;
  };


  /* store the original value */
  switch(arg_type) {
  case ARG_NO:
    break;
  default:
    if (value && orig_field) {
      if (no_free) {
        *orig_field = value;
      } else {
        if (*orig_field)
          free (*orig_field); /* free previous string */
        *orig_field = gengetopt_strdup (value);
      }
    }
  };

  return 0; /* OK */
}


int
hdf5_parser_internal (
  int argc, char **argv, struct hdf5_args_info *args_info,
                        struct hdf5_parser_params *params, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error_occurred = 0;
  struct hdf5_args_info local_args_info;
  
  int override;
  int initialize;
  int check_required;
  int check_ambiguity;
  
  package_name = argv[0];
  
  override = params->override;
  initialize = params->initialize;
  check_required = params->check_required;
  check_ambiguity = params->check_ambiguity;

  if (initialize)
    hdf5_parser_init (args_info);

  hdf5_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = params->print_errors;
  optopt = '?';

  while (1)
    {
      int option_index = 0;

      static struct option long_options[] = {
        { "version",	0, NULL, 'V' },
        { "help",	0, NULL, 'h' },
        { "format",	1, NULL, 'f' },
        { "output",	1, NULL, 'o' },
        { "compound",	0, NULL, 0 },
        { "matlab",	0, NULL, 0 },
        { 0,  0, 0, 0 }
      };

      c = getopt_long (argc, argv, "Vhf:o:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'V':	/* Print version and exit.  */
          hdf5_parser_print_version ();
          hdf5_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'h':	/* Show this help message..  */
        
        
          if (update_arg( 0 , 
               0 , &(args_info->help_given),
              &(local_args_info.help_given), optarg, 0, 0, ARG_NO,
              check_ambiguity, override, 0, 0,
              "help", 'h',
              additional_error))
            goto failure;
        
          break;
        case 'f':	/* Use the specified parser, see below for a list..  */
        
        
          if (update_arg( (void *)&(args_info->format_arg), 
               &(args_info->format_orig), &(args_info->format_given),
              &(local_args_info.format_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "format", 'f',
              additional_error))
            goto failure;
        
          break;
        case 'o':	/* Write result to specified output file, or stdout if omitted..  */
        
        
          if (update_arg( (void *)&(args_info->output_arg), 
               &(args_info->output_orig), &(args_info->output_given),
              &(local_args_info.output_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "output", 'o',
              additional_error))
            goto failure;
        
          break;

        case 0:	/* Long option with no short option */
          /* Use the compound data type to tightly couple timestamps and values..  */
          if (strcmp (long_options[option_index].name, "compound") == 0)
          {
          
          
            if (update_arg( 0 , 
                 0 , &(args_info->compound_given),
                &(local_args_info.compound_given), optarg, 0, 0, ARG_NO,
                check_ambiguity, override, 0, 0,
                "compound", '-',
                additional_error))
              goto failure;
          
          }
          /* Make the generated file easy to read with matlab..  */
          else if (strcmp (long_options[option_index].name, "matlab") == 0)
          {
          
          
            if (update_arg( 0 , 
                 0 , &(args_info->matlab_given),
                &(local_args_info.matlab_given), optarg, 0, 0, ARG_NO,
                check_ambiguity, override, 0, 0,
                "matlab", '-',
                additional_error))
              goto failure;
          
          }
          
          break;
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", HDF5_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */




  hdf5_parser_release (&local_args_info);

  if ( error_occurred )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
      int found_prog_name = 0;
      /* whether program name, i.e., argv[0], is in the remaining args
         (this may happen with some implementations of getopt,
          but surely not with the one included by gengetopt) */

      i = optind;
      while (i < argc)
        if (argv[i++] == argv[0]) {
          found_prog_name = 1;
          break;
        }
      i = 0;

      args_info->inputs_num = argc - optind - found_prog_name;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        if (argv[optind++] != argv[0])
          args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind-1]) ;
    }

  return 0;

failure:
  
  hdf5_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
