/** @file ute-shnot-clo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef UTE_SHNOT_CLO_H
#define UTE_SHNOT_CLO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef SHNOT_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define SHNOT_PARSER_PACKAGE "ute shnot"
#endif

#ifndef SHNOT_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define SHNOT_PARSER_PACKAGE_NAME "ute shnot"
#endif

#ifndef SHNOT_PARSER_VERSION
/** @brief the program version */
#define SHNOT_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct shnot_args_info
{
  const char *version_help; /**< @brief Print version and exit help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  char * output_arg;	/**< @brief Write result to specified output file.  */
  char * output_orig;	/**< @brief Write result to specified output file original value given at command line.  */
  const char *output_help; /**< @brief Write result to specified output file help description.  */
  int interval_arg;	/**< @brief Make a snapshot every SECS seconds (default: 300).  */
  char * interval_orig;	/**< @brief Make a snapshot every SECS seconds (default: 300) original value given at command line.  */
  const char *interval_help; /**< @brief Make a snapshot every SECS seconds (default: 300) help description.  */
  int modulus_arg;	/**< @brief Start SECS seconds past midnight (default 0).  */
  char * modulus_orig;	/**< @brief Start SECS seconds past midnight (default 0) original value given at command line.  */
  const char *modulus_help; /**< @brief Start SECS seconds past midnight (default 0) help description.  */
  char * zone_arg;	/**< @brief Use time zone NAME for tty output (default UTC).  */
  char * zone_orig;	/**< @brief Use time zone NAME for tty output (default UTC) original value given at command line.  */
  const char *zone_help; /**< @brief Use time zone NAME for tty output (default UTC) help description.  */
  
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int interval_given ;	/**< @brief Whether interval was given.  */
  unsigned int modulus_given ;	/**< @brief Whether modulus was given.  */
  unsigned int zone_given ;	/**< @brief Whether zone was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct shnot_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure shnot_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure shnot_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *shnot_args_info_purpose;
/** @brief the usage string of the program */
extern const char *shnot_args_info_usage;
/** @brief the description string of the program */
extern const char *shnot_args_info_description;
/** @brief all the lines making the help output */
extern const char *shnot_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int shnot_parser (int argc, char **argv,
  struct shnot_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use shnot_parser_ext() instead
 */
int shnot_parser2 (int argc, char **argv,
  struct shnot_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int shnot_parser_ext (int argc, char **argv,
  struct shnot_args_info *args_info,
  struct shnot_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int shnot_parser_dump(FILE *outfile,
  struct shnot_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int shnot_parser_file_save(const char *filename,
  struct shnot_args_info *args_info);

/**
 * Print the help
 */
void shnot_parser_print_help(void);
/**
 * Print the version
 */
void shnot_parser_print_version(void);

/**
 * Initializes all the fields a shnot_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void shnot_parser_params_init(struct shnot_parser_params *params);

/**
 * Allocates dynamically a shnot_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized shnot_parser_params structure
 */
struct shnot_parser_params *shnot_parser_params_create(void);

/**
 * Initializes the passed shnot_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void shnot_parser_init (struct shnot_args_info *args_info);
/**
 * Deallocates the string fields of the shnot_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void shnot_parser_free (struct shnot_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int shnot_parser_required (struct shnot_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* UTE_SHNOT_CLO_H */
